<bugID>1362866<Summary>Fix tab switch spinner regression (re-)introduced by bug 1054740</Summary><Description>Created attachment 8865228
Regression in graph (last data point)

The patches in bug 1351677 originally landed in order to avoid an unnecessary tab switch when restoring a session. The patches did this by moving the initial browser to the selected browser slot, meaning that it was a tab move instead of a tab switch. This fixed the tab switch regression that had been introduced by bug 1256472.

Bug 1054740 ended up reverting that optimization, and the regression has returned.

The tab switch spinner tracker that I have at https://mikeconley.github.io/bug1310250/ is showing an increase in the number of clients seeing tab switch spinners by ~10%. This is almost certainly caused by the same reason that bug 1351677 tried to fix: the initial tab switch during session restore doesn't occur fast enough to avoid the tab switch spinner.

I'm happy with the simplification that Dao introduced in bug 1054740. I'm less happy with the regression in this metric, and I'm hoping we can find some kind of compromise.</Description></bugID>